package cn.ibizlab.humanresource.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.humanresource.domain.HRReward;
import cn.ibizlab.humanresource.core.humanresource.filter.HRRewardSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HRReward] 服务对象接口
 */
public interface IHRRewardService extends IService<HRReward>{

    boolean create(HRReward et) ;
    void createBatch(List<HRReward> list) ;
    boolean update(HRReward et) ;
    void updateBatch(List<HRReward> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HRReward get(String key) ;
    HRReward getDraft(HRReward et) ;
    boolean checkKey(HRReward et) ;
    boolean save(HRReward et) ;
    void saveBatch(List<HRReward> list) ;
    Page<HRReward> searchDefault(HRRewardSearchContext context) ;
    List<HRReward> selectByHremployeeid(String employeeid) ;
    void removeByHremployeeid(String employeeid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HRReward> getHrrewardByIds(List<String> ids) ;
    List<HRReward> getHrrewardByEntities(List<HRReward> entities) ;
}


